//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// August 1999
//

#include <qcombobox.h>

#include <Tracer.h>
#include <CalServer.h>

#include "AccuracySelector.h"

AccuracySelector::AccuracySelector(QWidget * parent, const char * name)
  : QComboBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}


void AccuracySelector::init()
{
  PROC
  CalState * state = calServer.state();
  clear();
  if(state->accuracyLevel()->isActive()){
    setEnabled(true);
    const vector<AccuracyLevel> & accus = state->accuracyLevel()->allowedValues();
    for(unsigned j = 0; j < accus.size(); j++){
      insertItem(toString(accus[j]).c_str(),j);
    }
    connect(this, SIGNAL(activated(int)), this, SLOT(myactivated(int)));
  } else {
    setEnabled(false);
  }
  ENDPROC
}

void AccuracySelector::update()
{
  PROC
  init();
  ENDPROC
}

void AccuracySelector::myactivated(int i)
{
  PROC
  calServer.state()->accuracyLevel()->set(static_cast<AccuracyLevel>(i));
  emit calStateIsUpdated();
  ENDPROC
}







