//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// August 1999
//

#include <Tracer.h>
#include <CalServer.h>

#include <qspinbox.h>

#include "CcdTemperatureSelector.h"

CcdTemperatureSelector::CcdTemperatureSelector(QWidget * parent, const char * name)
  : QSpinBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}


void CcdTemperatureSelector::init()
{
  PROC
  if(calServer.state()->temperature()->isActive()){
    setEnabled(true);
    setValue(static_cast<int>(calServer.state()->temperature()->get()));
    setRange(static_cast<int>(calServer.state()->temperature()->min()),
	     static_cast<int>(calServer.state()->temperature()->max()));
  } else {
    setEnabled(false);
  }
  connect(this, SIGNAL(valueChanged(int)), this, SLOT(myvaluechanged(int)));
  ENDPROC
}

void CcdTemperatureSelector::update()
{
  PROC
  init();
  ENDPROC
}

void CcdTemperatureSelector::myvaluechanged(int v)
{
  PROC
  calServer.state()->temperature()->set(v);
  emit calStateIsUpdated();
  ENDPROC
}
