//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// March 09, 1999
//

#include <Tracer.h>
#include <CalView.h>

#include <qspinbox.h>
#include <qtooltip.h>
#include <sstream>

#include "EnergySelector.h"

EnergySelector::EnergySelector(QWidget * parent, const char * name)
  : QSpinBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}


void EnergySelector::init()
{
  PROC
  CalViewState * state = calViewServer.state();
  if(state->E.isActive()){
    setEnabled(true);
    setValue(static_cast<int>(state->E.get()));
    setRange(static_cast<int>(state->E.min()), static_cast<int>(state->E.max()));
    stringstream s;
    s << "Range: " << state->E.min() << " to " << state->E.max();
    QToolTip::add(this, s.str().c_str());
  } else {
    setEnabled(false);
  }
  connect(this, SIGNAL(valueChanged(int)), this, SLOT(myvaluechanged(int)));
  ENDPROC
}

void EnergySelector::update()
{
  PROC
  init();
  ENDPROC
}

void EnergySelector::myvaluechanged(int v)
{
  PROC
  CalViewState * state = calViewServer.state();
  state->E.set(v);
  emit calStateIsUpdated();
  ENDPROC
}
