//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// March 9, 1999
//

#include <string>

#include <Xmm.h>
#include <Tracer.h>
#include <CalServer.h>

#include "FilterBgroup.h"

#include <qcombobox.h> 

FilterBgroup::FilterBgroup(QWidget * parent, const char * name)
  : QComboBox(parent, name)
{
  PROC
  init();
  ENDPROC
}

void FilterBgroup::init()
{
  PROC
  CalState * state = calServer.state();
  clear();
  if (state->filter()->isActive()) {
    setEnabled(true);
    const vector<Filter> & filters = state->filter()->allowedValues();
    for (unsigned j = 0; j < filters.size(); j++) {
      insertItem(Xmm::toString(filters[j]).c_str(),j);
    }
    connect(this, SIGNAL(activated(const QString &)), this, SLOT(myactivated(const QString &)));
  } else {
    setEnabled(false);
  }
  ENDPROC
}

void FilterBgroup::update()
{
  PROC
  init();
  ENDPROC
}

void FilterBgroup::myactivated(const QString & f)
{
  PROC
  calServer.state()->filter()->set(Xmm::toFilter(string(f.ascii())));
  emit calStateIsUpdated();
  ENDPROC
}
