//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// March 9, 1999
//

#include <map>
#include <string>

#include <Xmm.h>
#include <Tracer.h>
#include <CalServer.h>

#include "ModeBgroup.h"

#include <qcombobox.h> 

ModeBgroup::ModeBgroup(QWidget * parent, const char * name )
  : QComboBox(parent, name)
{
  PROC
  init();
  ENDPROC
}

void ModeBgroup::init()
{
  PROC
  CalState * state = calServer.state();
  clear();
  if (state->mode()->isActive()) {
    setEnabled(true);
    const vector<Mode> &modes = state->mode()->allowedValues();
    for (unsigned j = 0; j < modes.size(); j++) {
      insertItem(Xmm::toString(modes[j]).c_str(),j);
    }
    connect(this, SIGNAL(activated(const QString &)), this, SLOT(myactivated(const QString &)));
  } else {
    setEnabled(false);
  }
  ENDPROC
}

void ModeBgroup::update()
{
  PROC
  init();
  ENDPROC
}

void ModeBgroup::myactivated(const QString & m)
{
  PROC
  calServer.state()->mode()->set(Xmm::toMode(string(m.ascii())));
  emit calStateIsUpdated();
  ENDPROC
}
