//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// February 24, 1999
//

#include <string>
#include <sstream>
#include <vector>

#include <Tracer.h>
#include <CalServer.h>

#include "NodeBgroup.h"

#include <qcombobox.h>

NodeBgroup::NodeBgroup(QWidget * parent, const char * name )
  : QComboBox(parent, name)
{
  PROC
  init();
  ENDPROC
}

void NodeBgroup::init()
{
  PROC
  CalState * state = calServer.state();
  clear(); 
  if (state->node()->isActive()) {
    setEnabled(true);
    const vector<Node> &nodes = state->node()->allowedValues();
    for (unsigned j = 0; j < nodes.size(); j++) {
      insertItem(Xmm::toString(nodes[j]).c_str(), j);
    }
    connect(this, SIGNAL(activated(const QString &)), this, SLOT(myactivated(const QString &)));
  } else {
    setEnabled(false);
  }
  ENDPROC
}

void NodeBgroup::update()
{
  PROC
  init();
  ENDPROC
}

void NodeBgroup::myactivated(const QString & n)
{
  PROC
  calServer.state()->node()->set(Xmm::toNode(string(n.ascii())));
  emit calStateIsUpdated();
  ENDPROC
}

