//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// August 1999
//

#include <Tracer.h>
#include <CalServer.h>
#include <STime.h>

#include "ObservationStartTimeSelector.h"

ObservationStartTimeSelector::ObservationStartTimeSelector(QWidget * parent,
							   const char * name)
  : QLineEdit(parent,name)
{
  PROC
  init();  
  ENDPROC
}

void ObservationStartTimeSelector::init()
{
  PROC
  if(calServer.state()->exposureStartTime()->isActive()){
    setEnabled(true);
    STime t = calServer.state()->exposureStartTime()->get();
    t = t - t.fracSeconds();
    setText(QString(t.toString().c_str()));
    setMaxLength(19);
  } else {
    setEnabled(false);
  }

  //connect(this, SIGNAL(textChanged(const QString &)), this, SLOT(myvaluechanged(const QString &)));
  //connect(this, SIGNAL(returnPressed()), this, SLOT(myvaluechanged()));
  connect(this, SIGNAL(textChanged(const QString &)), this, SLOT(myvaluechanged()));

  ENDPROC
}

void ObservationStartTimeSelector::update()
{
  PROC
  init();
  ENDPROC
}
/*
  void ObservationStartTimeSelector::myvaluechanged(const QString & s)
  {
    PROC
    calServer.state()->exposureStartTime()->set(STime(string(s)));
    emit calStateIsUpdated();
    ENDPROC
  }
  */
void ObservationStartTimeSelector::myvaluechanged()
{
  PROC

  // Update the time if new time is valid
  if (STime::isValidTime(string(text().ascii()))) {
     calServer.state()->exposureStartTime()->set(STime(string(text().ascii())));
     emit calStateIsUpdated();
  }
  ENDPROC
}
