//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// August 1999
//

#include <Tracer.h>
#include <CalServer.h>

#include <qcombobox.h>

#include "RandomizationSelector.h"

RandomizationSelector::RandomizationSelector(QWidget * parent, const char * name)
  : QComboBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}

void RandomizationSelector::init()
{
  PROC
  CalState * state = calServer.state();
  clear();
  if(state->randomize()->isActive()){
    setEnabled(true);
    insertItem("no", 0);
    insertItem("yes", 1);
    state->randomize()->get() ? setCurrentItem(1) : setCurrentItem(0);
    connect(this, SIGNAL(activated(const QString &)), this, SLOT(myvaluechanged(const QString &)));
  } else {
    setEnabled(false);
  }
  ENDPROC
}

void RandomizationSelector::update()
{
  PROC
  init();
  ENDPROC
}

void RandomizationSelector::myvaluechanged(const QString & s)
{
  PROC
  if(s == "yes")
    calServer.state()->randomize()->set(true);
  else
    calServer.state()->randomize()->set(false);
  emit calStateIsUpdated();
  ENDPROC
}
