//
// XMM Science Analysis System
//
// Giuseppe Vacanti (European Space Agency) 
// March 2000
//

#include <Tracer.h>
#include <CalView.h>

#include <qspinbox.h>
#include <qtooltip.h>
#include <sstream>

#include "ThetaSelector.h"

ThetaSelector::ThetaSelector(QWidget * parent, const char * name)
  : QSpinBox(parent,name)
{
  PROC
  init();  
  ENDPROC
}


void ThetaSelector::init()
{
  PROC
  CalViewState * state = calViewServer.state();
  if(state->theta.isActive()){
    setEnabled(true);
    setValue(static_cast<int>(state->theta.get()));
    setRange(static_cast<int>(state->theta.min()), static_cast<int>(state->theta.max()));
    stringstream s;
    s << "Range: " << state->theta.min() << " to " << state->theta.max();
    QToolTip::add(this, s.str().c_str());
  } else {
    setEnabled(false);
  }
  connect(this, SIGNAL(valueChanged(int)), this, SLOT(myvaluechanged(int)));
  ENDPROC
}

void ThetaSelector::update()
{
  PROC
  init();
  ENDPROC
}

void ThetaSelector::myvaluechanged(int v)
{
  PROC
  CalViewState * state = calViewServer.state();
  state->theta.set(v);
  emit calStateIsUpdated();
  ENDPROC
}
